<template>
  <div class="flex px-6 mt-12">
    <div class="w-[40%]  min-h-[30%]">
      <h1 class="text-7xl font-black mb-4">{{ manga?.title }}</h1>
      <h2 class="text-5xl font-black mb-2">{{ manga?.jap_title }}</h2>
      <template v-if="manga?.themes?.length">
        <h5 class="mb-0 mt-2">Themes</h5>
        <tags-cloud class="mb-3" :tags="manga?.themes ?? []" />
      </template>
      <template v-if="manga?.genres?.length">
        <h5 class="mb-0 mt-2">Genres</h5>
        <tags-cloud class="mb-3" :tags="manga?.genres ?? []" type="secondary" />
      </template>
      <p class="font-semibold">{{ manga?.description }}</p>
      <Detail
          @add-to-library="updateUserLibrary"
          :data="detailsData"
          class="bg-white rounded-3xl shadow-lg w-[160%] relative z-20 ml-3 mt-8"
      />
    </div>
    <div class="w-[60%] px-12">
      <img class="rounded-3xl w-full h-[55vh] object-cover relative z-0" :src="manga?.picture" alt="cover"/>
    </div>
  </div>
  <h4 class="px-8 my-8 text-lg">You have <span class="font-semibold">{{owned.length}}/{{manga?.volumes}}</span> volumes ({{((owned.length/manga?.volumes) * 100).toFixed(2)}}% complete)</h4>
  <div class="my-12 px-8 grid grid-cols-6 gap-x-2 gap-y-8 w-full ">
    <cover
        v-for="volume in manga?.volumes"
        @own="ownedVolume(volume)"
        :src="manga?.picture"
        :number="volume"
        :owned="owned.includes(volume)"
        class="col-span-1"
    />
  </div>
</template>

<script>
import Detail from "../../components/manga/Detail.vue";
import TagsCloud from "../../components/TagsCloud.vue";
import Cover from "../../components/manga/Cover.vue";
import title from "../../helpers/title.js";

export default {
  name: "Details",
  components: {Cover, TagsCloud, Detail},
  data() {
    return {
      dummyManga: {
        title: 'Tengen Toppa Gurren Lagann',
        jap_title: '天元突破グレンラガン',
        description: 'In their closed-off underground village, Kamina and Shimon chafe at the limits imposed by the village elder. Yet all this will change, when Shimon stumbles across a fantastic device - just as the village\'s peace is broken by a violent intrusion.',
        image: 'https://wallup.net/wp-content/uploads/2018/09/26/179457-Tengen_Toppa_Gurren_Lagann-748x420.jpg',
        volumes: 10,
        chapters: 65,
        releaseDate: 2007,
        status: 1,
        tags: ['romance', 'shonen', 'adventure', 'tragedy', 'mecha'],
        userFavorite: false
      },
      owned: [],
      manga: null,
      inLibrary: false
    }
  },

  mounted() {
    this.$axios.get(`/mangas/${this.$route.params.id}`).then(({data}) => {
      this.manga = data
      title(data?.title ?? "")
    })
    if(this.$store.auth){
      this.$axios.get(`/users/${this.$store.user.id}/relations/mangas`).then(({data}) => {
        this.inLibrary = data.find(manga => manga.api_id === this.manga.api_id) !== undefined
        if(this.inLibrary){
          this.owned = data.find(manga => manga.api_id === this.manga.api_id).volumes ?? []
        }
      })
    }

  },

  computed: {
    detailsData() {
      return {
        status: {'Completed': 1, 'Ongoing': 0}[this.manga?.status ?? 'Ongoing'],
        volumes: this.manga?.volumes,
        chapters: this.manga?.chapters,
        releaseDate: this.manga?.release_date,
        library: this.inLibrary
      }
    },
  },

  methods:{
    updateUserLibrary(){
      if(this.$store.auth) {
        const params = new URLSearchParams();
        if (this.inLibrary) {
          params.append('id', this.manga.id);
          this.$axios.delete(`/users/${this.$store.user.id}/relations/mangas`, {
            data: params,
            headers: {
              'Access-Control-Allow-Origin': 'http://localhost/* , http://127.0.0.1/*',
              'Authorization': this.$store.userToken
            }
          }).then(({status}) => {
            if(status === 200){
              this.inLibrary = false
              this.owned = []
            }
          })
        } else {
          params.append('ids', this.manga.id);
          this.$axios.post(`/users/${this.$store.user.id}/relations/mangas`, params, {
            headers: {
              'Access-Control-Allow-Origin': 'http://localhost/* , http://127.0.0.1/*',
              'Authorization': this.$store.userToken
            }
          }).then(({status}) => {
            if(status === 200){
              this.inLibrary = true
            }
          })

        }
      }
    },

    ownedVolume(volume){
      if(!this.owned.includes(volume)){
        this.owned.push(volume)
      }
      if(this.$store.auth){
        const params = new URLSearchParams();
        params.set('volumes', JSON.stringify(this.owned))
        this.$axios.post(`/users/${this.$store.user.id}/relations/mangas/${this.manga.id}`, params, {
          headers: {
            'Access-Control-Allow-Origin': 'http://localhost/* , http://127.0.0.1/*',
            'Authorization': this.$store.userToken
          }
        })
      }
    }
  },

  watch:{
    async '$route.params.id'(data, old){
      if(old && data){
        await this.$axios.get(`/mangas/${this.$route.params.id}`).then(({data}) => {
          this.manga = data
          title(data?.title ?? "")
        })

        if(this.$store.auth){
          await this.$axios.get(`/users/${this.$store.user.id}/relations/mangas`).then(({data}) => {
            this.inLibrary = data.find(manga => manga.api_id === this.manga.api_id) !== undefined
            if(this.inLibrary){
              this.owned = data[0].volumes
            }else{
              this.owned = []
            }
          })
        }

      }
    }
  }
}
</script>